/*
 * Subverse
 * Copyright (C) 2007 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Avatar.h"
#include "World.h"
#include "Utils.h"

Avatar::Avatar(World* w) :
        Element(w, "avatar", AVATAR) {
    g = Singleton<Graph>::getInstance();
    setCreature(true);
    setWorking(false);
    //setMaxTime(6);
}

bool Avatar::tecla(int t) {
    if (g->isKeyDown(t) || g->isKeyHeld(t)) {
        return true;
    }
    return false;
}

void Avatar::execute() {
    if (tecla(SDLK_UP)) move(UP);
    else if (tecla(SDLK_DOWN)) move(DOWN);
    else if (tecla(SDLK_RIGHT)) move(RIGHT);
    else if (tecla(SDLK_LEFT)) move(LEFT);
    else if (tecla(SDLK_LCTRL)) {
        Element* e = getAround(ELEMENT, FRONT);
        if (e != NULL) attack(e);
    } else if (tecla(SDLK_LALT)) {
        Element* e = getAround(ELEMENT, FRONT);
        if (e != NULL) eat(e);
    } else if (tecla(SDLK_SPACE)) {
        Element* e = getAround(ELEMENT, FRONT);
        if (e != NULL) sendMessage(e, "ola");
    }
}

Avatar::~Avatar() {
}
