/*
 * Subverse
 * Copyright (C) 2009 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Cyclope.h"
#include "World.h"
#include <stdlib.h>
#include <time.h>

Cyclope::Cyclope(World* w) :
        Element(w, "cyclope", CYCLOPE) {
    setCreature(true);

    contadorAleatorio = 0;
}

void Cyclope::execute() {
    bool found = false;
    Vision *vision = getVision();
    Element* e =  NULL;

    //Caso esteja sendo atacado, ataca e sai aleatoriamente
    if (isUnderAttack() 	) {
        Element* front = getAround(ELEMENT, FRONT);
        if (front != NULL) {
            attack(getAttacker());
        }
        vagar();
    } else {
        do {
            e = vision->getNext(ELEMENT);
            if (e != NULL) {
                if (getHelth() < 20) {
                    if ((e->getType() == TREE) && (e->getFood() > 0)) {
                        found = true;
                    } else if ((e->isCreature()) && (!e->isAlive()) && (e->getFood() > 0)) {
                        found = true;
                    }
                } else if (isUnderAttack() && (e == getAttacker()) && e->isAlive()) {
                    found = true;
                } else if ((e->getType() == AVATAR) && e->isCreature() && e->isAlive()) {
                    found = true;
                }
                if ((e->getType() == CYCLOPE) && (e->isAlive())) {
                    e->sendMessage(this, "oi");
                }
            }
        } while ((!found) && (e != NULL));

        if (found) {
            Element* front = getAround(ELEMENT, FRONT);

            if ((front != NULL) && (e == front))  {
                if ((e->getType() != CYCLOPE) && (e->getType() != AVATAR) && (e->isCreature())) {
                    attack(e);
                } else if ((e->getType() == TREE) && (e->getFood() > 0)) {
                    eat(e);
                } else if ((e->isCreature()) && (!e->isAlive()) && (e->getFood() > 0)) {
                    eat(e);
                } else vagar();
            } else {
                vagar();
            }
        } else {
            if (getDirection() == 1) {
                setDirection(3);
            } else if (getDirection() == 2)
                setDirection(3);
        }
        vagar();
    }

    if (hasMessage()) {
        Message *msg = getMessage();
        if (this != msg->getSender()) {
            if ((msg->getContent().compare("oi") == 0)) {
                string t = "ola ";
                t += intToString(msg->getSender()->getId());
                setTalk(t);
            }
        }
    }
}

/*
 * Implementacao de sub-comportamentos
 */
void Cyclope::vagar() {
    if (contadorAleatorio > 4) {
        contadorAleatorio = 0;
        move((rand() % 4) * 2);
    }
    int dir = getDirection();
    if (!move(dir)) {
        switch (dir) {
        case UP: move(LEFT); break;
        case LEFT: move(DOWN); break;
        case DOWN: move(RIGHT); break;
        case RIGHT: move(UP); break;
        }
    }
    contadorAleatorio++;
}

Cyclope::~Cyclope() {
}
