/*
 * Shortcourse of "Development of Computer Games: Basic Module"
 * in: I2TS 2009
 * 8th International Information and Telecommunication Technologies
 * Symposium
 *
 * Copyright (C) 2009 Saulo Popov Zambiasi and Max Ricardo Benin
 *
 * This source code is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com or mbenin@gmail.com
 */

#ifndef SINGLETON_H_
#define SINGLETON_H_

template<class T> class Singleton {
private:
	Singleton();
	~Singleton();
	Singleton(Singleton const&);
	Singleton& operator=(Singleton const&);
public:
	/// Retorna o ponteiro para o singleton
	static T* getInstance() {
		static T instance;
		return &instance;
	}
};

#endif /* SINGLETON_H_ */
