/*
 * Subverse
 * Copyright (C) 2007 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Cyclope.h"
#include "World.h"


Cyclope::Cyclope(World* w) :
        Element(w, "cyclope", CYCLOPE) {
    setCreature(true);
}

void Cyclope::execute() {
    bool found = false;
    Vision *vision = getVision();
    Element* e =  NULL;

    //Caso esteja sendo atacado, ataca e sai aleatoriamente
    if (isUnderAttack() 	) {
        Element* front = getAround(ELEMENT, FRONT);
        if (front != NULL) {
            attack(getAttacker());
        }

        if (getDirection() == 1) {
            setDirection(3);
        } else if (getDirection() == 2) {
            setDirection(3);
        }

        move((rand() % 4) * 2);
    } else {
        do {
            e = vision->getNext(ELEMENT);
            if (e != NULL) {
                if (getHelth() < 20) {
                    if ((e->getType() == TREE) && (e->getFood() > 0)) {
                        found = true;
                    } else if ((e->isCreature()) && (!e->isAlive()) && (e->getFood() > 0)) {
                        found = true;
                    }
                } else if (isUnderAttack() && (e == getAttacker()) && e->isAlive()) {
                    found = true;
                } else if ((e->getType() == AVATAR) && e->isCreature() && e->isAlive()) {
                    found = true;
                }
            }
        } while ((!found) && (e != NULL));

        if (found) {
            Element* front = getAround(ELEMENT, FRONT);
            /*Element* left  = getAround(ELEMENT, LEFT);
            Element* right = getAround(ELEMENT, RIGHT);
            Element* back  = getAround(ELEMENT, BACK);*/

            if ((front != NULL) && (e == front))  {
                if ((e->getType() != CYCLOPE) && (e->getType() != AVATAR) && (e->isCreature())) {
                    attack(e);
                } else if ((e->getType() == TREE) && (e->getFood() > 0)) {
                    eat(e);
                } else if ((e->isCreature()) && (!e->isAlive()) && (e->getFood() > 0)) {
                    eat(e);
                } else move((rand() % 4) * 2);
                //} else if ((left != NULL) && (e == left)) {
                //move(RIGHT); //DOWN, RIGHT, UP, LEFT, DOWN_RIGHT, DOWN_LEFT, UP_RIGHT, UP_LEFT
            } else {
                if (e->getX() > getX()) move(RIGHT);
                else if (e->getX() < getX()) move(LEFT);
                else if (e->getY() > getY()) move(DOWN);
                else if (e->getY() < getY()) move(UP);
            }

        } else {
            if (getDirection() == 1) {
                setDirection(3);
            } else if (getDirection() == 2)
                setDirection(3);
        }

        move((rand() % 4) * 2);
    }
}

Cyclope::~Cyclope() {
}
